<?php
namespace Teknisa\CADFIS\Services;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;
use Teknisa\CADFIS\Services\GeneralService as GeneralService;
use Teknisa\CADFIS\Services\EndeFornService as EndeFornService;

class FornecedorService
{
    protected $dataSourceName = "import_fornecedor";
    protected $entityManager;
    protected $crudService;
    protected $generalService;
    protected $endefornService;
    
    public function __construct($entityManager, $crudService, Connection $connection, Environment $environment)
    {
        $this->entityManager = $entityManager;
        $this->crudService = $crudService;
        $this->connection = $connection;
        $this->environment = $environment;
        $this->generalService = new GeneralService($this->connection, $this->environment);
        $this->endefornService = new EndeFornService($this->entityManager, $this->crudService, $this->connection, $this->environment);
    }
    
    public function verifyCdMunicipioExists($row, $columnNameCdPais = 'CDPAIS', $columnNameSgEstado = 'SGESTADO', $columnNameCdMunicipio = 'CDMUNICIPIO')
    {
        return $this->generalService->verifyCdMunicipioExists($row, $columnNameCdPais, $columnNameSgEstado, $columnNameCdMunicipio);
    }
    
    public function verifyCdPaisExists($row, $columnNameCdPais = 'CDPAIS')
    {
        return $this->generalService->verifyCdPaisExists($row, $columnNameCdPais);
    }
    
    public function verifySgEstadoExists($row, $columnNameCdPais = 'CDPAIS', $columnNameSgEstado = 'SGESTADO')
    {
        return $this->generalService->verifySgEstadoExists($row, $columnNameCdPais, $columnNameSgEstado);
    }
    
    public function verifyFornecedorExists($row)
    {
        return $this->generalService->verifyFornecedorExists($row);
    }
    
    public function saveImport($rows)
    {
        $this->crudService->save($this->dataSourceName, $rows);
        $this->endefornService->saveImport($rows);
    }
}    